
const rom BYTE hbchan[] = { // base addresses for channels
0x20,0x20,0x40,
0x40,0x60,0x60,
0x80,0x80
};

void Loa_parm(BYTE preset, BYTE channel)
{
BYTE b, y;

    ClrWdt(); // kick the watchdog
	for(y = 0; y < 8; y++)
		{
		b = chtabl[channel] | hbchan[y];
		if(y == 2 || y == 3)
			WrReg(b, 0x3f);
		else
			WrReg(b, adrtab[preset][y]);
		++y;
		b = chtabh[channel] | hbchan[y];
		if(y == 2 || y == 3)
			WrReg(b, 0x3f);
		else
			WrReg(b, adrtab[preset][y]);
		}
	b = adrtab[preset][y];
	WrReg(b, channel | 0xc0);
	octave[channel] = ((b / 16) & 3) * 12;
	WrReg(0xbd, b & 0xc0);
	for(channel *= 8;;)
		{
		dinam[channel++] = adrtab[preset][++y];
		if((channel & 7) == 0)
			break;
		}
}

void NoteOn(BYTE note, BYTE speed)
{
    immb0 = tabh[note] | 0x20;
    WrReg(0xa0, tabf[note]);
    WrReg(chtabl[0] | 0x40, dinam[speed / 16]); 
    WrReg(chtabh[0] | 0x40, dinam[speed / 16 + 4]);
    WrReg(0xb0, immb0);
}

void NoteOff(void)
{
    immb0 &= 0x1f;
    WrReg(0xb0, immb0);
}

BYTE Get_midi(void)
{
BYTE c;

	while(servpt == inpupt); // wait for midi data
    c = area[servpt++]; // get data from serial queue
    servpt &= 0x3F; // circular buffer range is 0..0x3F
    return c;
}

void Midi_parser(void)
{
BYTE note, speed, c;

	if(servpt == inpupt)
		return;
	switch(c = Get_midi())
		{
		case 0x90:
			excom = c;
			note = Get_midi() - 35;
			speed = Get_midi();
            NoteOn(note, speed);
			break;
		case 0x80:
			note = Get_midi() - 35;
			speed = Get_midi();
            NoteOff();
			break;
		default:
			if(excom == 0x90)
				{
				note = c - 35;
				speed = Get_midi();
				if(speed == 0)
                    NoteOff();
				else
                    NoteOn(note, speed);
				}
		}
}

void vmain1(void)
{
    Loa_parm(2, 0);
    for(;;)
        {
        ClrWdt(); // kick the watchdog
        Midi_parser();
        }
}
