//----------------
//- FM routines  -
//----------------
void Fatab1(BYTE pos)
{
BYTE a;

	if((a = total + delta) > 0x3f)
		a = 0x3f;
	total = a;
	tabv1[pos] = a | ksr;
}

void Fatab2(BYTE pos)
{
BYTE a;

	if((a = total - delta) > 127)
		a = 0;
	total = a;
	tabv1[pos] = a | ksr;
}

void LoadPreset(BYTE num, BYTE fmchan)
{
WORD x;
BYTE a, y;

    ClrWdt(); // kick the watchdog
	x = num * 9;
	a = prtabl[x+2];
	tabv1[4] = a; // KSR included
	ksr = a & 0xc0;
	a &= 0x3f;
	total = a;
	delta = a / 16;
	if(total & 8) ++delta;
	pusha = total;
	for(y = 3; y < 128; y--)
		Fatab1(y);
	total = pusha;
	for(y = 5; y < 8; y++)
		Fatab2(y);
	a = prtabl[x+3];
	tabv2[4] = a; // KSR included
	ksr = a & 0xc0;
	a = prtabl[x+3] & 0x3f;
	total = a;
	delta = a / 4;
	if(total & 0x02) ++delta;
	pusha = total;
	for(y = 11; y > 7; --y)
		Fatab1(y);
	total = pusha;
	for(y = 13; y < 16; ++y)
		Fatab2(y);
	y = x;
	x = fmchan;
	for(hchan = 0x20; hchan < 0xa0; hchan += 0x20)
		{
        WrReg(chtabl[x] | hchan, prtabl[y++]);
        WrReg(chtabh[x] | hchan, prtabl[y++]);
		}
    WrReg(fmchan | 0xC0, prtabl[y]); // Feedback-Connection
}

void Upconv(void)
{
BYTE a, x, y;

	for(y = 0, x = 0; x < 8; ++x)
		{
		if((a = bumidi[x]) > 0x7F) // if NOTE ON present
			{
            a &= 0x7F; // remove ON bit
            if(a >= 12) // if possible then offset n octaves down
                a -= 12;
			bufpre[y] = a; // store note
			prevel[y++] = buvel[x] / 16; // store speed (scaled to 0..7) 
			}
		}
	bufpre[y] = 0;
}

void Poly7(void) // seven notes polyphony
{
BYTE x, y;

    for(x = 0; x < 7; ++x) // scan note buffer
        {
        if(bufpre[x] == 0) // if end of buffer
            break; // exit loop
        for(y = 0; y < 7; ++y) // scan canale buffer
            {
            if(bufpre[x] == canale[y]) // if note present
                {
                canale[y] |= 0x80; // set flag
                break; // end loop
                }
            }
        if(y >= 7) // if note NOT present in the buffer
            {
            for(y = 0; y < 7; ++y) // scan triger buffer
                {
                if(triger[y] == 0) // if free channel
                    {
                    if(y < (7-1)) // if not the last channel
                        {
                        // pack buffers
                        }
                    canale[y] = bufpre[x] | 0x80; // save input note and set flag
               		polvol[y] = prevel[x] / 16; // save input speed
                    }
                }
            }
        } 

    for(x = 0; x < 7; ++x) // scan actual status
        {
        y = address[x]; // get channel address
        if(canale[x] > 127) // if note ON flag set
            {
            if(triger[x] == 0) // if not playing
                {
                triger[x] |= 0x80; // set playing flag
                canale[x] &= ~0x80; // reset note ON flag
                hreg[y] = tabh[canale[x]] | 0x20; // store reg B0 image
                lreg[y] = tabf[canale[x]]; // store reg A0 image
                outportb(ADDR, y | 0xa0); // select address 0xa0..0xa6
                outportb(DATA, lreg[y]); // write freq (low) to 0xa0..0xa6
                outportb(ADDR, chtabl[y] | 0x40);
//                outportb(DATA, dinam[polvol[x]]);
                outportb(ADDR, chtabh[y] | 0x40);
//                outportb(DATA, dinam[polvol[x] +4]);
                outportb(ADDR, y | 0xb0); // select address 0xb0..0xb6
                outportb(DATA, hreg[y]); // write freq (high) or 0x20 to 0xb0..0xb6
                }
            }
        else // if note ON flag not set
            {
            if(triger[x]) // if playing
                {
                triger[x] = 0; // reset playing flag
                outportb(ADDR, y | 0xb0); // select address 0xb0..0xb6
                outportb(DATA, hreg[y] & 0x1F); // write freq (high) or 0x20 to 0xb0..0xb6
                }
            }
        }
}

void Poly(void) // polyphonic sound handler
{
BYTE a, x, y;

		x = 0xff;
lab240: x++;
fori1:  a = bufpre[x];
        if(a == 0) goto oftrg;
        y = 0;
forj1:  if(canale[y] == bufpre[x]) goto lab230;
		if(++y != 8) goto forj1;
        y = 0;
forj2:  if(triger[y] == 0) goto lab210;
		if(++y != 8) goto forj2;
        goto lab240;
lab230: canale[y] |= 0x80;
		if(triger[y] != 0) goto lab240;
lab210: if(++y == 8) goto salva;
        polybf = x;
		x = y - 1;
		comodo = address[x];
sposta: canale[x] = canale[y];
		triger[x] = triger[y];
		address[x] = address[y];
		polvol[x++] = polvol[y++];
		if(y != 8) goto sposta;
		address[x] = comodo;
		triger[x] *= 2;
		x = polybf;
salva:	canale[--y] = bufpre[x] | 0x80;
		polvol[y] = prevel[x] / 16;
        goto lab240;
oftrg:  x = 0;
trgof:  a = canale[x] ^ triger[x];
		if(a > 127) goto charge;
		canale[x] = a;
		goto incrm;
charge: if(canale[x] & 0x80)
            {
            triger[x] = 0x80;
            canale[x] &= 0x7f;
            }
        else
            triger[x] = 0x00;
        y = canale[x];
		if(triger[x] > 127) goto onvoic;
        a = address[x];
        peadd = a;
        a |= 0xb0;
        outportb(ADDR, a);
        y = peadd;
        a = hreg[y];
        a &= 0x1f;
        outportb(DATA, a);
        a = 0;
        goto incrm;
onvoic: a = address[x];
        peadd = a;
        a |= 0xa0;
        outportb(ADDR, a);
        a = tabf[y];
        outportb(DATA, a);
        comodo = a;
		a = peadd | 0xb0;
        outportb(ADDR, a);
		a = (triger[x] / 4) | tabh[y];
        outportb(DATA, a);
		y = peadd;
		hreg[y] = a;
		lreg[y] = comodo;
        WrReg(chtabl[address[x]] | 0x40, tabv1[polvol[x]]); 
        WrReg(chtabh[address[x]] | 0x40, tabv2[polvol[x]]); 
incrm:  if(++x != 8) goto trgof;
		return;
}
